<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Different Solutions GmbH <info@different-solutions.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * tx_dsvtigercrm
 */
class tx_dsvtigercrm {
    /**
     * Setup powermail hook -> ['powermail']['PM_SubmitAfterMarkerHook']
     * @param  array $obj
     * @param  array $markerArray
     * @param  array $data
     * @return void
     */
    function PM_SubmitAfterMarkerHook(&$obj, &$markerArray, &$data) {
        if ($obj->cObj->data['tx_dsvtigercrm_enable']) {
            require_once(t3lib_extMgm::extPath('ds_vtiger_crm', 'tx_dsvtigercrm_rest.php'));

            $pid  = $obj->cObj->data['pid'];
            $user = $obj->cObj->data['tx_dsvtigercrm_userName'];
            $url  = $obj->cObj->data['tx_dsvtigercrm_target'];
            $key  = $obj->cObj->data['tx_dsvtigercrm_accessKey'];
            $mod  = $obj->cObj->data['tx_dsvtigercrm_action'];
            
            $client = new VtigerConnector($url, $user, $key, $mod);

            if ($client->connectToVtiger()) {
                if ($client->prepareDataForModule($data, $pid)) {
                    if ($client->sendDataToModule()) {
                        if (!$client->disconnectFromVtiger()) {
                            $error_message = 'Please check dev_log informations';
                        }
                    } else {
                        $error_message = 'Please check response data';
                    }
                } else {
                    $error_message = 'Please check post data';
                }
            } else {
                $error_message = 'Please check meta informations like username, accesskey, url and module';
            }

            if ($error_message) {
                $conf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['ds_vtiger_crm']);

                if ($conf['log_err'] && strpos($GLOBALS['TYPO3_CONF_VARS']['EXT']['extList'], 'devlog')) {
                    $error_data = array(
                        'meta'  => array(
                            'url'       => $url,
                            'username'  => $user,
                            'accesskey' => $key,
                            'module'    => $mod,
                            'pid'       => $pid,
                        ),
                        'post' => $data,
                        'response' => $client->getLastResponse(),
                    );

                    t3lib_div::devLog($error_message, 'ds_vtiger_crm', 3, $error_data);
                }
            }
        }
    }
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ds_vtiger_crm/class.tx_dsvtigercrm.php'])    {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ds_vtiger_crm/class.tx_dsvtigercrm.php']);
}

?>
